(* Le code écrit en cours, le code à compléter est 
   à partir de la ligne 60. :*)

(* Création d'un échiquier vide *)
let create_board n =
  Array.init n (fun _ -> Array.make n false)

(* Dans l'échiquier donné, est que la colonne au dessus de (row, col) est libre *)
let rec free_column board row col =
  if row < 0 then true
  else
    not (board.(row).(col)) &&
    free_column board (row-1) col

(* Dans l'échiquier donné, est que la diagonale gauche au dessus
   de (row, col) est libre.  *)

let rec free_diagonal_left board row col =
  if row < 0 || col < 0 then true
  else
    not (board.(row).(col)) &&
    free_diagonal_left board (row-1) (col-1)

(* Dans l'échiquier donné, est que la diagonale droite au dessus
   de (row, col) est libre.  *)

let rec free_diagonal_right board row col n =
  if row < 0 || col >= n then true
  else
    not (board.(row).(col)) &&
    free_diagonal_right board (row-1) (col+1) n

(* Recherche d'une solution avec retour arrière *)
let nqueens f n =
  (* num: nombre de reines posées *)
  let board = create_board n in
  let rec search row =
    if n = row then
      (* solution trouvée *)
      f board
    else begin
      (* solution pas trouvée *)
      for k = 0 to n - 1 do
        if free_column board row k &&
           free_diagonal_left board row k &&
           free_diagonal_right board row k n then
          begin
            board.(row).(k) <- true;
            search (row+1);
            (* ici, le retour arrière, on revient de l'appel
               récursif, on restore l'état précédent et
               on continue la boucle for, i.e. on continue
               de chercher.*)
            board.(row).(k) <- false;
          end
      done
    end
  in
  search 0

(* 1.1 *)
let compatible r1 c1 r2 c2 = failwith "todo"

(* 1.2 *)
let rec compatible_list row col other_queens =
  failwith "todo"

(* 1.3 *)
let nqueens_list f n = failwith "todo"

let time f arg =
  Gc.full_major (); (* on force le GC pour éviter (sans garantie)
                       qu'il s'éxécute pendant notre fonction.*)
  Gc.compact ();
  let t0 = Unix.gettimeofday () in
  let r = f arg in
  let t1 = Unix.gettimeofday () in
  r, (t1 -. t0) *. 1000.

(* 1.4 *)
let main () =
  for i = 0 to 14 do
    let count = ref 0 in
    let _, t = time (nqueens (fun _board -> incr count)) i in
    Printf.printf "Original: %d -> %d (%fms)\n%!" i !count t;
    (* compléter ici *)

  done

let () = main () (* commenter pour les questions suivantes *)

(* 1.5 La fonction print_list est dans le fichier utils.ml *)

(* 1.6 *)
let test_print_4 () = failwith "todo"

(*
let () = test_print_4 () (* commenter pour les questions suivantes *)
*)

(* 2.1 *)
exception Found of (int * int) list

let search_one_solution () =
  failwith "todo"


  (*
let () = search_one_solution () (* commenter pour les questions suivantes *)
*)
(* 2.2 *)
let nqueens_random n =
  failwith "todo"

let search_random_solution n =
  failwith "todo"

(* 2. 3 *)
let test_random () =
  failwith "todo"

(*
  let () = test_random ()
  *)